import Vue from 'vue';
import { Interceptor } from '@zeedhi/core';
import router from './router';
import store from './store';
import App from './App.vue';
import { vuetify } from './plugins';
import './components';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.config.productionTip = false;

Interceptor.addRequestSuccess((config) => {

    const token = JSON.parse(<string>localStorage.getItem('APP_LOGIN_TOKEN'));
    const hash = JSON.parse(<string>localStorage.getItem('APP_LOGIN_HASH'));
    const productId = JSON.parse(<string>localStorage.getItem('APP_LOGIN_PRODUCT_ID'));
    if (token) {
        config.headers['OAuth-Token'] = token;
    }
    if (hash) {
        config.headers['OAuth-Hash'] = hash;
        config.headers['OAuth-Project'] = productId;
    }
    return config;
});

new Vue({
  router,
  store,
  vuetify,
  render: (h) => h(App),
}).$mount('#app');
